/** Source code example for "A Practical Introduction to Data
    Structures and Algorithm Analysis, 3rd Edition (Java)" 
    by Clifford A. Shaffer
    Copyright 2008-2011 by Clifford A. Shaffer
*/

class DLink<E> {             // Doubly linked list node
  private E element;         // Value for this node
  private DLink<E> next;     // Pointer to next node in list
  private DLink<E> prev;     // Pointer to previous node

  // Constructors
  DLink(E it, DLink<E> n, DLink<E> p)
  { element = it;  next = n; prev = p; }
  DLink(DLink<E> n, DLink<E> p) { next = n;  prev = p; }

  DLink<E> next() { return next; }
  DLink<E> setNext(DLink<E> nextval)
    { return next = nextval; }
  DLink<E> prev() { return prev; }
  DLink<E> setPrev(DLink<E> prevval)
    { return prev = prevval; }
  E element() { return element; }
  E setElement(E it) { return element = it; }
} // class DLink
