/** Source code example for "A Practical Introduction to Data
    Structures and Algorithm Analysis, 3rd Edition (Java)" 
    by Clifford A. Shaffer
    Copyright 2008-2011 by Clifford A. Shaffer
*/

import java.io.*;
import java.nio.*;

public class MemMain {

public static void main(String args[]) throws IOException {

  MemManager mymem = new MemManager(15);
  int[] stuff = new int[3];
  ByteBuffer bstuff = ByteBuffer.wrap(stuff);
  for (int i=0; i<3; i++)
	stuff[i] = i+10;

System.out.println("Do first request");
  MemHandle h = mymem.request(bstuff);

  int[] dum = mymem.getValue(h);

System.out.println("Do second request");
  MemHandle h2 = mymem.request(bstuff);

  mymem.release(h);

  System.in.read();
} // main

} // class MemMain
